{ big.pas
  Copyright 1998 Jorgen Dybdahl  (JDybdahl@compuserve.com)

  The digits are made up of zero'es and one's so they can be represented
  as binary numbers.

  1. First draw your digits in a text editor as shown to the left.
  2. 'x's represent '1' and '.' represent zero as shown to the right
     giving a binary representation of each line in each digit.
     Translate the binary number to something you can enter in your
     language (most languages do hexadecimal and decimal; C also accept
     octal).

                      binr      hex
                      --------------
     xx...xx.         11000110   c6
     xx...xx.         11000110   c6
     xx...xx.         11000110   c6
     xxxxxxxx         11111111   ff
     .....xx.         00000110   6
     .....xx.         00000110   6
     .....xx.         00000110   6

  3. Make a table

}

uses crt, dos;

type
  digitset = array [0..9,0..6] of byte;

const
  (**** CONFIG *************************************)
  {$define digitset2}
  hpos = 3;               { hours }
  ypos = 9;               { vertical offset }
  (*************************************************)

{$ifdef digitset1}
  numbers : digitset = (
       ( $07e,$0c3,$0c3,$0c3,$0c3,$0c3,$07e ),  { 0 }
       ( $018,$038,$018,$018,$018,$018,$07e ),  { 1 }
       ( $07e,$0c3,$003,$00c,$030,$0c0,$0ff ),  { 2 }
       ( $0ff,$006,$00c,$01c,$006,$083,$07e ),  { 3 }
       ( $0c6,$0c6,$0c6,$0ff,$006,$006,$006 ),  { 4 }
       ( $07f,$060,$060,$03c,$003,$083,$07e ),  { 5 }
       ( $07e,$0c1,$0c0,$0fe,$0c3,$0c3,$07e ),  { 6 }
       ( $0ff,$003,$006,$00c,$018,$030,$060 ),  { 7 }
       ( $07e,$0c3,$0c3,$07e,$0c3,$0c3,$07e ),  { 8 }
       ( $07e,$0c3,$0c3,$07f,$003,$083,$07e )); { 9 }
{$endif}
{$ifdef digitset2}
numbers : digitset = (
       ( $0ff,$0c3,$0c3,$0c3,$0c3,$0c3,$0ff ),  { 0 }
       ( $038,$018,$018,$018,$018,$018,$07e ),  { 1 }
       ( $0ff,$003,$003,$0ff,$0c0,$0c0,$0ff ),  { 2 }
       ( $0ff,$003,$003,$0ff,$003,$003,$0ff ),  { 3 }
       ( $0c3,$0c3,$0c3,$0ff,$003,$003,$003 ),  { 4 }
       ( $0ff,$0c0,$0c0,$0ff,$003,$003,$0ff ),  { 5 }
       ( $0ff,$0c0,$0c0,$0ff,$0c3,$0c3,$0ff ),  { 6 }
       ( $0ff,$003,$003,$003,$003,$003,$003 ),  { 7 }
       ( $0ff,$0c3,$0c3,$0ff,$0c3,$0c3,$0ff ),  { 8 }
       ( $0ff,$0c3,$0c3,$0ff,$003,$003,$0ff ));  { 9 }
{$endif}

  mpos = hpos+28;         { position of minutes }
  spos = hpos+55;         { ditto seconds }
  c1pos = hpos+22;        { ditto colon 1 }
  c2pos = hpos+50;        { ditto colon 2 }


procedure cursor(bot, top : byte);
var
  regs : registers;
begin
  regs.ah := 1;
  regs.bh := 0;
  regs.cx := (top shl 8) + bot;
  intr(16, regs);
end;

procedure printcolon(x : integer);
begin
  gotoxy(x,ypos+2);
  write('');
  gotoxy(x,ypos+4);
  write('');
end;

function bitTest(n, bitno : integer): boolean;
begin
  if (n and (1 shl bitno)) > 0 then bitTest := true
  else bitTest := false;
end;


procedure printDigit(x, n : integer);
var
  height, width, y : integer;
begin
  y := ypos;
  for height := 0 to 6 do begin
    gotoxy(x, y);
    for width := 7 downto 0 do begin
      if bitTest(numbers[n][height], width) then write('')
      else write(' ');
    end;
    inc(y);
  end;
end;



{ split into two digits }
procedure printDigits(x, n : integer);
begin
  printDigit(x, n div 10);
  printDigit(x+10, n mod 10);
end;


var
  hr, mn, sc, sc100 : word;
  ohr, omn, osc : word;         { old values }

BEGIN
  clrscr;
  cursor(255,255);              { cursor off }
  printcolon(c1pos);
  printcolon(c2pos);

  { set old values to impossible values }
  ohr := 25; omn := 61; osc := 61;

  repeat
    gettime(hr,mn,sc,sc100);
    { now what to print? }
    if hr <> ohr then begin
      printDigits(hpos, hr);
      ohr := hr;
    end;
    if mn <> omn then begin
      printDigits(mpos, mn);
      omn := mn;
    end;
    if sc <> osc then begin
      printDigits(spos, sc);
      osc := sc;
    end;
  until keypressed;
  cursor(7,6);
END.

